c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2006 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      DOUBLE PRECISION FUNCTION RVR(Mol , nchann, E) 
c
c	Interpolates 2-D double array Rate(MaxWell,MaxChan,Isize) to determine
c       k(E). Note that k(E) is stored in Rate as natural logs.
c
      IMPLICIT NONE
      INCLUDE 'declare1.inc'
      INTEGER Mol , nchann , IE
      DOUBLE PRECISION E , X , Y1 , Y2 , Y3 , Y
      SAVE 
 
      IF ( E.LE.Emax1 ) THEN
         IE = 1 + INT(E/Egrain1)                
         Y = Rate(Mol,nchann,IE)
      ELSE
        CALL NTERP( E , IE , X )
        Y1 = Rate(Mol,nchann,IE-1)
        Y2 = Rate(Mol,nchann,IE)
        Y3 = Rate(Mol,nchann,IE+1)
        CALL QUDINT(Y1,Y2,Y3,X,Y)           ! Y = interpolated ln(sum)
      ENDIF

       RVR = EXP(Y)        ! because Rsum is stored as natural log in MultiWell   
 
      RETURN
      END
